var $lgoms$crypto = require("crypto");
var $lgoms$nodefetch = require("node-fetch");
var $lgoms$querystring = require("querystring");

var $4632b150ccce7a0e$exports = {};
"use strict";


class $4632b150ccce7a0e$var$RedemptionClient {
    constructor(partnerId, transactionId, currency, opts){
        if (typeof partnerId !== "string") throw new Error("partnerId must be a string");
        if (typeof transactionId !== "string") throw new Error("transactionId must be a string");
        if (typeof currency !== "string") throw new Error("currency must be a string");
        if (typeof opts !== "object") throw new Error("opts must be an object");
        this.serverEndPoint = "/tracking/v1.2/redemption";
        this.scriptEndpoint = this.serverEndPoint + "/js";
        this.partnerId = partnerId;
        this.transactionId = transactionId;
        this.currency = currency;
        this.options = Object.assign({
            fetch: $lgoms$nodefetch,
            hostname: "api.myunidays.com",
            protocol: "https",
            testMode: false
        }, opts);
    }
    _toQueryString(redemption) {
        return "?PartnerId=" + $4632b150ccce7a0e$var$_encodeStringValue(this.partnerId) + "&TransactionId=" + $4632b150ccce7a0e$var$_encodeStringValue(this.transactionId) + "&MemberId=" + (redemption.memberId ? $4632b150ccce7a0e$var$_encodeStringValue(redemption.memberId) : "") + "&Currency=" + $4632b150ccce7a0e$var$_encodeStringValue(this.currency) + "&OrderTotal=" + (redemption.orderTotal ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.orderTotal) : "") + "&ItemsUNiDAYSDiscount=" + (redemption.itemsUNiDAYSDiscount ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.itemsUNiDAYSDiscount) : "") + "&Code=" + (redemption.code ? $4632b150ccce7a0e$var$_encodeStringValue(redemption.code) : "") + "&ItemsTax=" + (redemption.itemsTax ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.itemsTax) : "") + "&ShippingGross=" + (redemption.shippingGross ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.shippingGross) : "") + "&ShippingDiscount=" + (redemption.shippingDiscount ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.shippingDiscount) : "") + "&ItemsGross=" + (redemption.itemsGross ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.itemsGross) : "") + "&ItemsOtherDiscount=" + (redemption.itemsOtherDiscount ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.itemsOtherDiscount) : "") + "&UNiDAYSDiscountPercentage=" + (redemption.UNiDAYSDiscountPercentage ? $4632b150ccce7a0e$var$_encodeNumberValue(redemption.UNiDAYSDiscountPercentage) : "") + "&NewCustomer=" + (typeof redemption.newCustomer === "boolean" && redemption.newCustomer ? "True" : "");
    }
    getTrackingScriptUrl(redemption) {
        if (redemption == null) throw new Error("redemption is null or undefined");
        let queryString = this._toQueryString(redemption);
        return $4632b150ccce7a0e$var$_buildUri(this.options, this.scriptEndpoint, queryString) + (this.options.testMode ? "&Test=True" : "");
    }
    getSignedTrackingScriptUrl(redemption, key) {
        if (redemption == null) throw new Error("redemption is null or undefined");
        let queryString = this._toQueryString(redemption);
        queryString = $4632b150ccce7a0e$var$_signQueryString(queryString, key);
        return $4632b150ccce7a0e$var$_buildUri(this.options, this.scriptEndpoint, queryString) + (this.options.testMode ? "&Test=True" : "");
    }
    getTrackingServerUrl(redemption, key) {
        if (redemption == null) throw new Error("redemption is null or undefined");
        let queryString = this._toQueryString(redemption);
        queryString = $4632b150ccce7a0e$var$_signQueryString(queryString, key);
        return $4632b150ccce7a0e$var$_buildUri(this.options, this.serverEndPoint, queryString) + (this.options.testMode ? "&Test=True" : "");
    }
    recordRedemption(redemption, key) {
        if (redemption == null) throw new Error("redemption is null or undefined.");
        let queryString = this._toQueryString(redemption);
        queryString = $4632b150ccce7a0e$var$_signQueryString(queryString, key);
        let url = $4632b150ccce7a0e$var$_buildUri(this.options, this.serverEndPoint, queryString) + (this.options.testMode ? "&Test=True" : "");
        return this.options.fetch(url, {
            method: "POST",
            headers: {
                "User-Agent": "unidays-node-client-library/1.2"
            }
        });
    }
}
const $4632b150ccce7a0e$var$_encodeStringValue = (value)=>{
    if (value == null) return "";
    return encodeURIComponent(value).replace(/%20/g, "+");
};
const $4632b150ccce7a0e$var$_encodeNumberValue = (value)=>{
    if (value == null) return "";
    if ((typeof value).toLowerCase() !== "number") value = parseFloat(value);
    return (Math.round(value * 100) / 100).toFixed(2);
};
const $4632b150ccce7a0e$var$_signQueryString = (queryString, customerSecret)=>{
    const hmac = $lgoms$crypto.createHmac("sha512", Buffer.from(customerSecret, "base64"));
    let sig = hmac.update(queryString).digest("base64");
    return queryString + "&Signature=" + $4632b150ccce7a0e$var$_encodeStringValue(sig);
};
const $4632b150ccce7a0e$var$_buildUri = (options, path, query)=>{
    const protocol = options.protocol, hostname = options.hostname;
    return `${protocol}://${hostname}${path}${query}`;
};
$4632b150ccce7a0e$exports = $4632b150ccce7a0e$var$RedemptionClient;


var $6536b3aa47ba0d15$exports = {};
"use strict";


$6536b3aa47ba0d15$exports = class {
    constructor(key){
        this.key = Buffer.from(key, "base64");
    }
    validate(studentId, timestamp, hash) {
        if (hash !== this.hash(studentId, timestamp)) return null;
        const timeSinceEpoch = parseInt(timestamp);
        return new Date(timeSinceEpoch);
    }
    hash(studentId, timestamp) {
        const query = $lgoms$querystring.stringify({
            ud_s: studentId,
            ud_t: timestamp
        }).replace(/%[A-F\d]{2}/g, (m)=>m.toLowerCase());
        const hmac = $lgoms$crypto.createHmac("sha512", this.key);
        return hmac.update(`?${query}`).digest("base64");
    }
};


module.exports = {
    RedemptionClient: $4632b150ccce7a0e$exports,
    CodelessClient: $6536b3aa47ba0d15$exports
};


//# sourceMappingURL=main.js.map
