import {createHmac as $igyYK$createHmac} from "crypto";
import * as $igyYK$nodefetch from "node-fetch";
import {stringify as $igyYK$stringify} from "querystring";

var $e11a5d666a824cd0$exports = {};
var $3e2a7c44febea0e7$exports = {};
"use strict";


class $3e2a7c44febea0e7$var$RedemptionClient {
    constructor(partnerId, transactionId, currency, opts){
        if (typeof partnerId !== "string") throw new Error("partnerId must be a string");
        if (typeof transactionId !== "string") throw new Error("transactionId must be a string");
        if (typeof currency !== "string") throw new Error("currency must be a string");
        if (typeof opts !== "object") throw new Error("opts must be an object");
        this.serverEndPoint = "/tracking/v1.2/redemption";
        this.scriptEndpoint = this.serverEndPoint + "/js";
        this.partnerId = partnerId;
        this.transactionId = transactionId;
        this.currency = currency;
        this.options = Object.assign({
            fetch: $igyYK$nodefetch,
            hostname: "api.myunidays.com",
            protocol: "https",
            testMode: false
        }, opts);
    }
    _toQueryString(redemption) {
        return "?PartnerId=" + $3e2a7c44febea0e7$var$_encodeStringValue(this.partnerId) + "&TransactionId=" + $3e2a7c44febea0e7$var$_encodeStringValue(this.transactionId) + "&MemberId=" + (redemption.memberId ? $3e2a7c44febea0e7$var$_encodeStringValue(redemption.memberId) : "") + "&Currency=" + $3e2a7c44febea0e7$var$_encodeStringValue(this.currency) + "&OrderTotal=" + (redemption.orderTotal ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.orderTotal) : "") + "&ItemsUNiDAYSDiscount=" + (redemption.itemsUNiDAYSDiscount ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.itemsUNiDAYSDiscount) : "") + "&Code=" + (redemption.code ? $3e2a7c44febea0e7$var$_encodeStringValue(redemption.code) : "") + "&ItemsTax=" + (redemption.itemsTax ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.itemsTax) : "") + "&ShippingGross=" + (redemption.shippingGross ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.shippingGross) : "") + "&ShippingDiscount=" + (redemption.shippingDiscount ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.shippingDiscount) : "") + "&ItemsGross=" + (redemption.itemsGross ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.itemsGross) : "") + "&ItemsOtherDiscount=" + (redemption.itemsOtherDiscount ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.itemsOtherDiscount) : "") + "&UNiDAYSDiscountPercentage=" + (redemption.UNiDAYSDiscountPercentage ? $3e2a7c44febea0e7$var$_encodeNumberValue(redemption.UNiDAYSDiscountPercentage) : "") + "&NewCustomer=" + (typeof redemption.newCustomer === "boolean" && redemption.newCustomer ? "True" : "");
    }
    getTrackingScriptUrl(redemption) {
        if (redemption == null) throw new Error("redemption is null or undefined");
        let queryString = this._toQueryString(redemption);
        return $3e2a7c44febea0e7$var$_buildUri(this.options, this.scriptEndpoint, queryString) + (this.options.testMode ? "&Test=True" : "");
    }
    getSignedTrackingScriptUrl(redemption, key) {
        if (redemption == null) throw new Error("redemption is null or undefined");
        let queryString = this._toQueryString(redemption);
        queryString = $3e2a7c44febea0e7$var$_signQueryString(queryString, key);
        return $3e2a7c44febea0e7$var$_buildUri(this.options, this.scriptEndpoint, queryString) + (this.options.testMode ? "&Test=True" : "");
    }
    getTrackingServerUrl(redemption, key) {
        if (redemption == null) throw new Error("redemption is null or undefined");
        let queryString = this._toQueryString(redemption);
        queryString = $3e2a7c44febea0e7$var$_signQueryString(queryString, key);
        return $3e2a7c44febea0e7$var$_buildUri(this.options, this.serverEndPoint, queryString) + (this.options.testMode ? "&Test=True" : "");
    }
    recordRedemption(redemption, key) {
        if (redemption == null) throw new Error("redemption is null or undefined.");
        let queryString = this._toQueryString(redemption);
        queryString = $3e2a7c44febea0e7$var$_signQueryString(queryString, key);
        let url = $3e2a7c44febea0e7$var$_buildUri(this.options, this.serverEndPoint, queryString) + (this.options.testMode ? "&Test=True" : "");
        return this.options.fetch(url, {
            method: "POST",
            headers: {
                "User-Agent": "unidays-node-client-library/1.2"
            }
        });
    }
}
const $3e2a7c44febea0e7$var$_encodeStringValue = (value)=>{
    if (value == null) return "";
    return encodeURIComponent(value).replace(/%20/g, "+");
};
const $3e2a7c44febea0e7$var$_encodeNumberValue = (value)=>{
    if (value == null) return "";
    if ((typeof value).toLowerCase() !== "number") value = parseFloat(value);
    return (Math.round(value * 100) / 100).toFixed(2);
};
const $3e2a7c44febea0e7$var$_signQueryString = (queryString, customerSecret)=>{
    const hmac = $igyYK$createHmac("sha512", Buffer.from(customerSecret, "base64"));
    let sig = hmac.update(queryString).digest("base64");
    return queryString + "&Signature=" + $3e2a7c44febea0e7$var$_encodeStringValue(sig);
};
const $3e2a7c44febea0e7$var$_buildUri = (options, path, query)=>{
    const protocol = options.protocol, hostname = options.hostname;
    return `${protocol}://${hostname}${path}${query}`;
};
$3e2a7c44febea0e7$exports = $3e2a7c44febea0e7$var$RedemptionClient;


var $83b3191396da4228$exports = {};
"use strict";


$83b3191396da4228$exports = class {
    constructor(key){
        this.key = Buffer.from(key, "base64");
    }
    validate(studentId, timestamp, hash) {
        if (hash !== this.hash(studentId, timestamp)) return null;
        const timeSinceEpoch = parseInt(timestamp);
        return new Date(timeSinceEpoch);
    }
    hash(studentId, timestamp) {
        const query = $igyYK$stringify({
            ud_s: studentId,
            ud_t: timestamp
        }).replace(/%[A-F\d]{2}/g, (m)=>m.toLowerCase());
        const hmac = $igyYK$createHmac("sha512", this.key);
        return hmac.update(`?${query}`).digest("base64");
    }
};


$e11a5d666a824cd0$exports = {
    RedemptionClient: $3e2a7c44febea0e7$exports,
    CodelessClient: $83b3191396da4228$exports
};


export {$e11a5d666a824cd0$exports as default};
//# sourceMappingURL=module.js.map
